﻿Imports System.Data
Imports System.Data.SqlClient

Public Class Form1
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        'Set AutoGenerateColumns False.
        dataGridView1.AutoGenerateColumns = False

        'Set Columns Count. 
        dataGridView1.ColumnCount = 4

        'Add Columns.
        dataGridView1.Columns(0).Name = "SerialNo"
        dataGridView1.Columns(0).HeaderText = "Serial No."
        dataGridView1.Columns(0).DataPropertyName = "SerialNo"

        dataGridView1.Columns(1).Name = "CustomerId"
        dataGridView1.Columns(1).HeaderText = "Customer Id"
        dataGridView1.Columns(1).DataPropertyName = "CustomerID"

        dataGridView1.Columns(2).HeaderText = "Contact Name"
        dataGridView1.Columns(2).Name = "ContactName"
        dataGridView1.Columns(2).DataPropertyName = "ContactName"

        dataGridView1.Columns(3).Name = "Country"
        dataGridView1.Columns(3).HeaderText = "Country"
        dataGridView1.Columns(3).DataPropertyName = "Country"
        dataGridView1.DataSource = GetData("SELECT CustomerID, ContactName, Country FROM Customers")
    End Sub

    Private Shared Function GetData(ByVal query As String) As DataTable
        Dim dt As DataTable = New DataTable()
        Dim constr As String = "Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123"
        Using con As SqlConnection = New SqlConnection(constr)
            Using cmd As SqlCommand = New SqlCommand(query, con)
                cmd.CommandType = CommandType.Text
                con.Open()
                Using sdr As SqlDataReader = cmd.ExecuteReader()
                    'Add columns to DataTable.
                    dt.Columns.AddRange(New DataColumn(3) {New DataColumn("SerialNo"), _
                                                           New DataColumn("CustomerID"), _
                                                           New DataColumn("ContactName"), _
                                                           New DataColumn("Country")})

                    'Set AutoIncrement True for the First Column.
                    dt.Columns("SerialNo").AutoIncrement = True

                    'Set the Starting or Seed value.
                    dt.Columns("SerialNo").AutoIncrementSeed = 1

                    'Set the Increment value.
                    dt.Columns("SerialNo").AutoIncrementStep = 1
                    While sdr.Read()
                        dt.Rows.Add(Nothing, sdr("CustomerID"), sdr("ContactName"), sdr("Country"))
                    End While
                End Using

                con.Close()
            End Using
        End Using

        Return dt
    End Function
End Class
